import { delegateEvents as Ce, getNextElement as g, getNextMarker as b, insert as k, createComponent as c, effect as ae, setAttribute as ve, runHydrationEvents as me, template as p, spread as ot, hydrate as rt, render as it } from "solid-js/web";
import { createSignal as B, onMount as Le, onCleanup as at, For as lt, Show as v, createEffect as st, createContext as ct, useContext as dt } from "solid-js";
import { closeBrackets as ut, autocompletion as ft } from "@codemirror/autocomplete";
import { StateField as Se, RangeSet as le, Compartment as mt, EditorState as se, SelectionRange as gt, EditorSelection as pt, RangeSetBuilder as Me, Transaction as ht } from "@codemirror/state";
import { vim as kt } from "@replit/codemirror-vim";
import { EditorView as L, Decoration as w, WidgetType as Ae, ViewPlugin as De, keymap as bt } from "@codemirror/view";
import { syntaxTree as J, syntaxHighlighting as xt, HighlightStyle as vt } from "@codemirror/language";
import { defaultKeymap as yt, historyKeymap as $t, indentMore as wt, indentLess as _t, history as Ct } from "@codemirror/commands";
import { markdown as Lt, markdownLanguage as St } from "@codemirror/lang-markdown";
import { languages as Mt } from "@codemirror/language-data";
import { tags as d } from "@lezer/highlight";
const At = "data-ink-mde-ssr-hydration-marker", Dt = `[${At}]`, Ht = () => ({}), z = {
  array: "[object Array]",
  object: "[object Object]",
  string: "[object String]",
  undefined: "[object Undefined]",
  window: "[object Window]"
}, zt = (e) => {
  if (Object.prototype.toString.call(e) === z.object)
    return `[object ${e.constructor.name}]`;
}, V = (e, t) => zt(e) === t, Bt = (e, t) => {
  const n = /* @__PURE__ */ new WeakMap(), r = (o, i) => n.get(o) || (V(o, z.object) && n.set(o, !0), V(i, z.undefined)) ? o : V(o, z.array) && V(i, z.array) ? [...i] : V(o, z.object) && V(i, z.object) ? Object.keys(o).reduce((l, a) => (Object.hasOwn(i, a) ? l[a] = r(o[a], i[a]) : l[a] = o[a], l), {}) : i;
  return r(e, t);
}, q = (e, t) => Bt(e, t);
var O = /* @__PURE__ */ ((e) => (e.Auto = "auto", e.Dark = "dark", e.Light = "light", e))(O || {}), M = /* @__PURE__ */ ((e) => (e.Appearance = "appearance", e.Attribution = "attribution", e.Autocomplete = "autocomplete", e.Images = "images", e.ReadOnly = "readonly", e.Spellcheck = "spellcheck", e.Vim = "vim", e))(M || {}), m = /* @__PURE__ */ ((e) => (e.Bold = "bold", e.Code = "code", e.CodeBlock = "code_block", e.Heading = "heading", e.Image = "image", e.Italic = "italic", e.Link = "link", e.List = "list", e.OrderedList = "ordered_list", e.Quote = "quote", e.TaskList = "task_list", e))(m || {}), G = /* @__PURE__ */ ((e) => (e.Completion = "completion", e.Default = "default", e.Grammar = "grammar", e))(G || {}), ce = /* @__PURE__ */ ((e) => (e.End = "end", e.Start = "start", e))(ce || {});
const ye = () => document.createElement("div"), He = () => window.matchMedia("(prefers-color-scheme: dark)").matches, Et = (e) => e === O.Dark ? !0 : e === O.Light ? !1 : He(), ie = (e) => {
  const t = [
    { suffix: "border-radius", default: "0.25rem" },
    { suffix: "color", default: "currentColor" },
    { suffix: "flex-direction", default: "column" },
    { suffix: "font-family", default: "inherit" },
    { suffix: "block-background-color", default: "#121212", light: "#f5f5f5" },
    { suffix: "block-background-color-on-hover", default: "#0f0f0f", light: "#e0e0e0" },
    { suffix: "block-max-height", default: "20rem" },
    { suffix: "block-padding", default: "0.5rem" },
    { suffix: "code-background-color", default: "var(--ink-internal-block-background-color)" },
    { suffix: "code-color", default: "inherit" },
    { suffix: "code-font-family", default: "'Monaco', Courier, monospace" },
    { suffix: "editor-font-size", default: "1em" },
    { suffix: "editor-line-height", default: "2em" },
    { suffix: "editor-padding", default: "0.5rem" },
    { suffix: "inline-padding", default: "0.125rem" },
    { suffix: "modal-position", default: "fixed" },
    { suffix: "syntax-atom-color", default: "#d19a66" },
    { suffix: "syntax-comment-color", default: "#abb2bf" },
    { suffix: "syntax-comment-font-style", default: "italic" },
    { suffix: "syntax-emphasis-color", default: "inherit" },
    { suffix: "syntax-emphasis-font-style", default: "italic" },
    { suffix: "syntax-hashtag-background-color", default: "#222", light: "#eee" },
    { suffix: "syntax-hashtag-color", default: "inherit" },
    { suffix: "syntax-heading-color", default: "inherit" },
    { suffix: "syntax-heading-font-weight", default: "600" },
    { suffix: "syntax-heading1-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading1-font-size", default: "1.6em" },
    { suffix: "syntax-heading1-font-weight", default: "600" },
    { suffix: "syntax-heading2-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading2-font-size", default: "1.5em" },
    { suffix: "syntax-heading2-font-weight", default: "600" },
    { suffix: "syntax-heading3-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading3-font-size", default: "1.4em" },
    { suffix: "syntax-heading3-font-weight", default: "600" },
    { suffix: "syntax-heading4-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading4-font-size", default: "1.3em" },
    { suffix: "syntax-heading4-font-weight", default: "600" },
    { suffix: "syntax-heading5-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading5-font-size", default: "1.2em" },
    { suffix: "syntax-heading5-font-weight", default: "600" },
    { suffix: "syntax-heading6-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading6-font-size", default: "1.1em" },
    { suffix: "syntax-heading6-font-weight", default: "600" },
    { suffix: "syntax-highlight-background-color", default: "#555555" },
    { suffix: "syntax-keyword-color", default: "#c678dd" },
    { suffix: "syntax-link-color", default: "inherit" },
    { suffix: "syntax-meta-color", default: "#abb2bf" },
    { suffix: "syntax-monospace-color", default: "var(--ink-internal-code-color)" },
    { suffix: "syntax-monospace-font-family", default: "var(--ink-internal-code-font-family)" },
    { suffix: "syntax-name-color", default: "#d19a66" },
    { suffix: "syntax-name-label-color", default: "#abb2bf" },
    { suffix: "syntax-name-property-color", default: "#96c0d8" },
    { suffix: "syntax-name-property-definition-color", default: "#e06c75" },
    { suffix: "syntax-name-variable-color", default: "#e06c75" },
    { suffix: "syntax-name-variable-definition-color", default: "#e5c07b" },
    { suffix: "syntax-name-variable-local-color", default: "#d19a66" },
    { suffix: "syntax-name-variable-special-color", default: "inherit" },
    { suffix: "syntax-number-color", default: "#d19a66" },
    { suffix: "syntax-operator-color", default: "#96c0d8" },
    { suffix: "syntax-processing-instruction-color", default: "#444444", light: "#bbbbbb" },
    { suffix: "syntax-punctuation-color", default: "#abb2bf" },
    { suffix: "syntax-strikethrough-color", default: "inherit" },
    { suffix: "syntax-strikethrough-text-decoration", default: "line-through" },
    { suffix: "syntax-string-color", default: "#98c379" },
    { suffix: "syntax-string-special-color", default: "inherit" },
    { suffix: "syntax-strong-color", default: "inherit" },
    { suffix: "syntax-strong-font-weight", default: "600" },
    { suffix: "syntax-url-color", default: "#aaaaaa", light: "#666666" }
  ], n = !Et(e.options.interface.appearance);
  return t.map((r) => {
    const o = n && r.light ? r.light : r.default;
    return `--ink-internal-${r.suffix}: var(--ink-${r.suffix}, ${o});`;
  });
}, $e = () => [
  L.theme({}, { dark: !0 })
], we = () => [
  L.theme({}, { dark: !1 })
];
class jt extends Ae {
  constructor() {
    super();
  }
  eq() {
    return !0;
  }
  toDOM() {
    const t = document.createElement("div"), n = t.appendChild(document.createElement("span")), r = t.appendChild(document.createElement("a"));
    return t.setAttribute("aria-hidden", "true"), t.style.bottom = "0", t.style.fontSize = "0.75em", t.style.opacity = "0.5", t.style.position = "absolute", t.style.right = "0", n.innerText = "powered by ", r.href = "https://github.com/voracious/ink-mde", r.innerText = "ink-mde", r.rel = "noopener noreferrer", r.target = "_blank", r.style.color = "var(--ink-internal-color)", r.style.fontWeight = "600", r.style.textDecoration = "none", t;
  }
}
const Vt = L.baseTheme({
  ".cm-content": {
    paddingBottom: "2em"
  }
}), Ot = Se.define({
  create(e) {
    return le.of(_e().range(e.doc.length));
  },
  update(e, t) {
    return le.of(_e().range(t.newDoc.length));
  },
  provide(e) {
    return L.decorations.from(e);
  }
}), _e = () => w.widget({
  widget: new jt(),
  side: 1,
  block: !0
}), Tt = () => [
  Vt,
  Ot
];
class Nt extends Ae {
  url;
  constructor({ url: t }) {
    super(), this.url = t;
  }
  eq(t) {
    return t.url === this.url;
  }
  toDOM() {
    const t = document.createElement("div"), n = t.appendChild(document.createElement("div")), r = n.appendChild(document.createElement("figure")), o = r.appendChild(document.createElement("img"));
    return t.setAttribute("aria-hidden", "true"), t.className = "cm-image-container", n.className = "cm-image-backdrop", r.className = "cm-image-figure", o.className = "cm-image-img", o.src = this.url, t.style.paddingBottom = "0.5rem", t.style.paddingTop = "0.5rem", n.classList.add("cm-image-backdrop"), n.style.borderRadius = "var(--ink-internal-border-radius)", n.style.display = "flex", n.style.alignItems = "center", n.style.justifyContent = "center", n.style.overflow = "hidden", n.style.maxWidth = "100%", r.style.margin = "0", o.style.display = "block", o.style.maxHeight = "var(--ink-internal-block-max-height)", o.style.maxWidth = "100%", o.style.width = "100%", t;
  }
}
const It = () => {
  const e = /!\[.*?\]\((?<url>.*?)\)/, t = (o) => w.widget({
    widget: new Nt(o),
    side: -1,
    block: !0
  }), n = (o) => {
    const i = [];
    return J(o).iterate({
      enter: ({ type: l, from: a, to: s }) => {
        if (l.name === "Image") {
          const u = e.exec(o.doc.sliceString(a, s));
          u && u.groups && u.groups.url && i.push(t({ url: u.groups.url }).range(o.doc.lineAt(a).from));
        }
      }
    }), i.length > 0 ? le.of(i) : w.none;
  };
  return [
    Se.define({
      create(o) {
        return n(o);
      },
      update(o, i) {
        return i.docChanged ? n(i.state) : o.map(i.changes);
      },
      provide(o) {
        return L.decorations.from(o);
      }
    })
  ];
}, Rt = () => L.contentAttributes.of({
  spellcheck: "true"
}), qt = (e, t) => {
  const n = e.resolver(t);
  return e.compartment.of(n);
}, Wt = (e) => e.extensions.map((t) => qt(t, e.options)), Ft = (e, t) => {
  const n = e.resolver(t);
  return e.compartment.reconfigure(n);
}, ze = (e) => e.extensions.map((t) => Ft(t, e.options)), H = (e) => {
  const t = new mt(), n = Ut[e];
  return {
    compartment: t,
    name: e,
    resolver: n
  };
}, Pt = () => [
  H(M.Appearance),
  H(M.Attribution),
  H(M.Autocomplete),
  H(M.Images),
  H(M.ReadOnly),
  H(M.Spellcheck),
  H(M.Vim)
], Ut = {
  appearance({ interface: { appearance: e } }) {
    return e === O.Dark ? $e() : e === O.Light ? we() : He() ? $e() : we();
  },
  attribution(e) {
    return e.interface.attribution ? Tt() : [];
  },
  autocomplete(e) {
    return e.interface.autocomplete ? ut() : [];
  },
  images(e) {
    return e.interface.images ? It() : [];
  },
  readonly(e) {
    return e.interface.readonly ? se.readOnly.of(!0) : se.readOnly.of(!1);
  },
  spellcheck(e) {
    return e.interface.spellcheck ? Rt() : [];
  },
  vim(e) {
    return e.vim ? kt() : [];
  }
}, de = () => {
  const e = {
    doc: "",
    files: {
      clipboard: !1,
      dragAndDrop: !1,
      handler: () => {
      },
      injectMarkup: !0,
      types: ["image/*"]
    },
    hooks: {
      afterUpdate: () => {
      },
      beforeUpdate: () => {
      }
    },
    interface: {
      appearance: O.Auto,
      attribution: !0,
      autocomplete: !1,
      images: !1,
      readonly: !1,
      spellcheck: !0,
      toolbar: !1
    },
    plugins: [],
    selections: [],
    toolbar: {
      bold: !0,
      code: !0,
      codeBlock: !0,
      heading: !0,
      image: !0,
      italic: !0,
      link: !0,
      list: !0,
      orderedList: !0,
      quote: !0,
      taskList: !0,
      upload: !1
    },
    vim: !1
  };
  return {
    editor: {},
    extensions: Pt(),
    options: e,
    root: ye(),
    target: ye()
  };
}, Xt = (e) => q(de(), e), ge = (e, t = {}) => {
  const [n, r] = B(Xt({ ...t, options: e }));
  return [n, r];
}, Kt = ([e]) => {
  const { editor: t } = e();
  t.destroy();
}, ue = ([e]) => {
  const { editor: t } = e();
  t.hasFocus || t.focus();
}, C = (e) => ({ ...{
  block: !1,
  line: !1,
  multiline: !1,
  nodes: [],
  prefix: "",
  prefixStates: [],
  suffix: ""
}, ...e }), Qt = {
  [m.Bold]: C({
    nodes: ["StrongEmphasis"],
    prefix: "**",
    suffix: "**"
  }),
  [m.Code]: C({
    nodes: ["InlineCode"],
    prefix: "`",
    suffix: "`"
  }),
  [m.CodeBlock]: C({
    block: !0,
    nodes: ["FencedCode"],
    prefix: "```\n",
    suffix: "\n```"
  }),
  [m.Heading]: C({
    multiline: !0,
    nodes: ["ATXHeading1", "ATXHeading2", "ATXHeading3", "ATXHeading4", "ATXHeading5", "ATXHeading6"],
    prefix: "# ",
    prefixStates: ["# ", "## ", "### ", "#### ", "##### ", "###### ", ""]
  }),
  [m.Image]: C({
    nodes: ["Image"],
    prefix: "![](",
    suffix: ")"
  }),
  [m.Italic]: C({
    nodes: ["Emphasis"],
    prefix: "*",
    suffix: "*"
  }),
  [m.Link]: C({
    nodes: ["Link"],
    prefix: "[](",
    suffix: ")"
  }),
  [m.OrderedList]: C({
    line: !0,
    multiline: !0,
    nodes: ["OrderedList"],
    prefix: "1. "
  }),
  [m.Quote]: C({
    line: !0,
    multiline: !0,
    nodes: ["Blockquote"],
    prefix: "> "
  }),
  [m.TaskList]: C({
    line: !0,
    multiline: !0,
    nodes: ["BulletList"],
    prefix: "- [ ] "
  }),
  [m.List]: C({
    line: !0,
    multiline: !0,
    nodes: ["BulletList"],
    prefix: "- "
  })
}, Be = ([e, t], n) => {
  const { editor: r } = e(), o = r.lineBlockAt(n.start), i = r.lineBlockAt(n.end);
  return { start: o.from, end: i.to };
}, Yt = ([e, t], n) => {
  const { editor: r } = e();
  let o = n.start;
  const i = [];
  for (; o <= n.end; ) {
    const l = r.lineBlockAt(o), a = Math.max(o, l.from), s = Math.min(o, l.to);
    i.push({ start: a, end: s }), o = l.to + 1;
  }
  return i;
}, Zt = ([e, t], n) => {
  const { editor: r } = e(), o = r.state.wordAt(n.start)?.from || n.start, i = r.state.wordAt(n.end)?.to || n.end;
  return { start: o, end: i };
}, Gt = ([e, t], n) => n || ee([e, t]).pop() || { start: 0, end: 0 }, Ee = ([e, t], n) => {
  const { editor: r } = e();
  return r.state.sliceDoc(n.start, n.end);
}, pe = ([e, t], n, r) => Jt(e(), r).find(({ type: i }) => n.nodes.includes(i.name)), Jt = ({ editor: { state: e } }, t) => {
  const n = [];
  return J(e).iterate({
    from: t.start,
    to: t.end,
    enter: ({ type: r, from: o, to: i }) => {
      n.push({ type: r, from: o, to: i });
    }
  }), n;
}, he = ([e, t], n, r) => {
  const o = Ee([e, t], r), i = n.prefix.length, l = n.suffix.length * -1 || o.length, a = o.slice(i, l);
  T([e, t], a, r);
}, en = ([e, t], n, r) => {
  const o = Be([e, t], r), i = pe([e, t], n, o);
  if (i) {
    const l = i.from, a = i.to;
    he([e, t], n, { start: l, end: a });
  } else {
    const l = n.prefix, a = n.suffix;
    te([e, t], { before: l, after: a, selection: o });
  }
}, tn = ([e, t], n, r) => {
  Yt([e, t], r).forEach((i) => {
    je([e, t], n, i);
  });
}, je = ([e, t], n, r) => {
  const o = Be([e, t], r), i = pe([e, t], n, o), l = n.prefixStates.length > 0;
  if (i && l)
    n.prefixStates.find((a, s) => {
      const u = i.from, x = i.to, y = Ee([e, t], { start: u, end: x }), S = y.startsWith(a);
      return S && T([e, t], y.replace(new RegExp(`^${a}`), n.prefixStates[s + 1]), { start: u, end: x }), S;
    });
  else if (i) {
    const a = i.from, s = i.to;
    he([e, t], n, { start: a, end: s });
  } else {
    const a = n.prefix, s = n.suffix;
    te([e, t], { before: a, after: s, selection: o });
  }
}, nn = ([e, t], n, r) => {
  const o = pe([e, t], n, r);
  if (o) {
    const i = o.from, l = o.to;
    he([e, t], n, { start: i, end: l });
  } else {
    const { start: i, end: l } = Zt([e, t], r), a = Array.isArray(n.prefix) ? n.prefix[0] : n.prefix, s = n.suffix;
    te([e, t], { before: a, after: s, selection: { start: i, end: l } });
  }
}, Ve = ([e, t], n, { selection: r } = {}) => {
  const o = Qt[n], i = Gt([e, t], r);
  o.block ? en([e, t], o, i) : o.multiline ? tn([e, t], o, i) : o.line ? je([e, t], o, i) : nn([e, t], o, i);
}, on = ([e]) => {
  const { editor: t } = e();
  return t.state.sliceDoc();
}, Oe = (e) => {
  const t = e.map((n) => gt.fromJSON({ anchor: n.start, head: n.end }));
  return pt.create(t);
}, rn = (e) => e.ranges.map((n) => ({
  end: n.anchor < n.head ? n.head : n.anchor,
  start: n.head < n.anchor ? n.head : n.anchor
})), ee = ([e]) => {
  const { editor: t } = e();
  return rn(t.state.selection);
}, T = ([e, t], n, r, o = !1) => {
  const { editor: i } = e();
  let l = r?.start, a = r?.end || r?.start;
  if (typeof l > "u") {
    const u = ee([e, t]).pop();
    l = u.start, a = u.end;
  }
  const s = { changes: { from: l, to: a, insert: n } };
  if (o) {
    const u = l === a ? l + n.length : l, x = l + n.length;
    Object.assign(s, { selection: { anchor: u, head: x } });
  }
  i.dispatch(
    i.state.update(s)
  );
}, an = [
  "Blockquote"
], ln = w.line({ attributes: { class: "cm-blockquote" } }), sn = w.line({ attributes: { class: "cm-blockquote-open" } }), cn = w.line({ attributes: { class: "cm-blockquote-close" } }), dn = De.define((e) => ({
  update: () => un(e)
}), { decorations: (e) => e.update() }), un = (e) => {
  const t = new Me(), n = J(e.state);
  for (const r of e.visibleRanges)
    for (let o = r.from; o < r.to; ) {
      const i = e.state.doc.lineAt(o);
      n.iterate({
        enter({ type: l, from: a, to: s }) {
          if (l.name !== "Document" && an.includes(l.name)) {
            t.add(i.from, i.from, ln);
            const u = e.state.doc.lineAt(a), x = e.state.doc.lineAt(s);
            return u.number === i.number && t.add(i.from, i.from, sn), x.number === i.number && t.add(i.from, i.from, cn), !1;
          }
        },
        from: i.from,
        to: i.to
      }), o = i.to + 1;
    }
  return t.finish();
}, fn = () => [
  dn
], mn = [
  "CodeBlock",
  "FencedCode",
  "HTMLBlock",
  "CommentBlock"
], gn = w.line({ attributes: { class: "cm-codeblock" } }), pn = w.line({ attributes: { class: "cm-codeblock-open" } }), hn = w.line({ attributes: { class: "cm-codeblock-close" } }), kn = w.mark({ attributes: { class: "cm-code" } }), bn = w.mark({ attributes: { class: "cm-code cm-code-open" } }), xn = w.mark({ attributes: { class: "cm-code cm-code-close" } }), vn = De.define((e) => ({
  update: () => yn(e)
}), { decorations: (e) => e.update() }), yn = (e) => {
  const t = new Me(), n = J(e.state);
  for (const r of e.visibleRanges)
    for (let o = r.from; o < r.to; ) {
      const i = e.state.doc.lineAt(o);
      let l;
      n.iterate({
        enter({ type: a, from: s, to: u }) {
          if (a.name !== "Document")
            if (mn.includes(a.name)) {
              t.add(i.from, i.from, gn);
              const x = e.state.doc.lineAt(s), y = e.state.doc.lineAt(u);
              return x.number === i.number && t.add(i.from, i.from, pn), y.number === i.number && t.add(i.from, i.from, hn), !1;
            } else
              a.name === "InlineCode" ? l = { from: s, to: u, innerFrom: s, innerTo: u } : a.name === "CodeMark" && (s === l.from ? (l.innerFrom = u, t.add(s, u, bn)) : u === l.to && (l.innerTo = s, t.add(l.innerFrom, l.innerTo, kn), t.add(s, u, xn)));
        },
        from: i.from,
        to: i.to
      }), o = i.to + 1;
    }
  return t.finish();
}, $n = () => [
  vn
], wn = () => [
  L.editorAttributes.of({
    class: "ink-mde-editor"
  }),
  L.contentAttributes.of({
    class: "ink-mde-editor-content"
  })
], _n = () => [
  ...wn()
], Cn = [
  {
    key: "Tab",
    run: ({ state: e, dispatch: t }) => e.selection.ranges.some((n) => !n.empty) ? wt({ state: e, dispatch: t }) : (t(
      e.update(e.replaceSelection("  "), {
        scrollIntoView: !0,
        annotations: ht.userEvent.of("input")
      })
    ), !0),
    shift: _t
  }
], Ln = () => bt.of([
  ...Cn,
  ...yt,
  ...$t
]), Sn = () => L.lineWrapping, Mn = () => [
  xt(
    vt.define([
      {
        tag: d.atom,
        color: "var(--ink-internal-syntax-atom-color)"
      },
      {
        tag: d.meta,
        color: "var(--ink-internal-syntax-meta-color)"
      },
      {
        tag: d.emphasis,
        color: "var(--ink-internal-syntax-emphasis-color)",
        fontStyle: "var(--ink-internal-syntax-emphasis-font-style)"
      },
      {
        tag: d.strong,
        color: "var(--ink-internal-syntax-strong-color)",
        fontWeight: "var(--ink-internal-syntax-strong-font-weight)"
      },
      {
        tag: d.strikethrough,
        color: "var(--ink-internal-syntax-strikethrough-color)",
        textDecoration: "var(--ink-internal-syntax-strikethrough-text-decoration)"
      },
      {
        tag: d.comment,
        color: "var(--ink-internal-syntax-comment-color)",
        fontStyle: "var(--ink-internal-syntax-comment-font-style)"
      },
      {
        tag: d.monospace,
        color: "var(--ink-internal-syntax-code-color)",
        fontFamily: "var(--ink-internal-syntax-code-font-family)"
      },
      {
        tag: d.name,
        color: "var(--ink-internal-syntax-name-color)"
      },
      {
        tag: d.labelName,
        color: "var(--ink-internal-syntax-name-label-color)"
      },
      {
        tag: d.propertyName,
        color: "var(--ink-internal-syntax-name-property-color)"
      },
      {
        tag: d.definition(d.propertyName),
        color: "var(--ink-internal-syntax-name-property-definition-color)"
      },
      {
        tag: d.variableName,
        color: "var(--ink-internal-syntax-name-variable-color)"
      },
      {
        tag: d.definition(d.variableName),
        color: "var(--ink-internal-syntax-name-variable-definition-color)"
      },
      {
        tag: d.local(d.variableName),
        color: "var(--ink-internal-syntax-name-variable-local-color)"
      },
      {
        tag: d.special(d.variableName),
        color: "var(--ink-internal-syntax-name-variable-special-color)"
      },
      {
        tag: d.heading,
        color: "var(--ink-internal-syntax-heading-color)",
        fontWeight: "var(--ink-internal-syntax-heading-font-weight)"
      },
      {
        tag: d.heading1,
        color: "var(--ink-internal-syntax-heading1-color)",
        fontSize: "var(--ink-internal-syntax-heading1-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading1-font-weight)"
      },
      {
        tag: d.heading2,
        color: "var(--ink-internal-syntax-heading2-color)",
        fontSize: "var(--ink-internal-syntax-heading2-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading2-font-weight)"
      },
      {
        tag: d.heading3,
        color: "var(--ink-internal-syntax-heading3-color)",
        fontSize: "var(--ink-internal-syntax-heading3-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading3-font-weight)"
      },
      {
        tag: d.heading4,
        color: "var(--ink-internal-syntax-heading4-color)",
        fontSize: "var(--ink-internal-syntax-heading4-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading4-font-weight)"
      },
      {
        tag: d.heading5,
        color: "var(--ink-internal-syntax-heading5-color)",
        fontSize: "var(--ink-internal-syntax-heading5-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading5-font-weight)"
      },
      {
        tag: d.heading6,
        color: "var(--ink-internal-syntax-heading6-color)",
        fontSize: "var(--ink-internal-syntax-heading6-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading6-font-weight)"
      },
      {
        tag: d.keyword,
        color: "var(--ink-internal-syntax-keyword-color)"
      },
      {
        tag: d.number,
        color: "var(--ink-internal-syntax-number-color)"
      },
      {
        tag: d.operator,
        color: "var(--ink-internal-syntax-operator-color)"
      },
      {
        tag: d.punctuation,
        color: "var(--ink-internal-syntax-punctuation-color)"
      },
      {
        tag: d.link,
        color: "var(--ink-internal-syntax-link-color)"
      },
      {
        tag: d.url,
        color: "var(--ink-internal-syntax-url-color)"
      },
      {
        tag: d.string,
        color: "var(--ink-internal-syntax-string-color)"
      },
      {
        tag: d.special(d.string),
        color: "var(--ink-internal-syntax-string-special-color)"
      },
      {
        tag: d.processingInstruction,
        color: "var(--ink-internal-syntax-processing-instruction-color)"
      }
    ])
  )
], An = (e) => {
  if (e.length > 0)
    return Oe(e);
}, Te = (e) => {
  const t = e.options.plugins.flatMap((o) => o.type === G.Completion ? o.value : []), n = e.options.plugins.flatMap((o) => o.type === G.Default ? o.value : []), r = e.options.plugins.flatMap((o) => o.type === G.Grammar ? o.value : []);
  return se.create({
    doc: e.options.doc,
    selection: An(e.options.selections),
    extensions: [
      ...Wt(e),
      ft({
        defaultKeymap: !0,
        icons: !1,
        override: t,
        optionClass: () => "ink-tooltip-option"
      }),
      fn(),
      $n(),
      Ct(),
      _n(),
      Ln(),
      Sn(),
      Lt({
        base: St,
        codeLanguages: Mt,
        extensions: r
      }),
      Mn(),
      ...n
    ]
  });
}, Dn = ([e, t], n) => {
  t(q(e(), { options: { doc: n } })), e().editor.setState(Te(e()));
}, Hn = ([e]) => e().options, zn = ([e, t], n) => {
  const r = ze(t(q(e(), { options: n })));
  e().editor.dispatch({
    effects: r
  });
}, Ne = (e, t = {}) => {
  if (t.selections)
    return Ie(e, t.selections);
  if (t.selection)
    return fe(e, t.selection);
  if (t.at)
    return Bn(e, t.at);
}, Bn = (e, t) => {
  const [n] = e;
  if (t === ce.Start)
    return fe(e, { start: 0, end: 0 });
  if (t === ce.End) {
    const r = n().editor.state.doc.length;
    return fe(e, { start: r, end: r });
  }
}, Ie = ([e], t) => {
  const { editor: n } = e();
  n.dispatch(
    n.state.update({
      selection: Oe(t)
    })
  );
}, fe = (e, t) => Ie(e, [t]), En = ([e], t) => {
  const { editor: n } = e();
  n.dispatch(
    n.state.update({
      changes: {
        from: 0,
        to: n.state.doc.length,
        insert: t
      }
    })
  );
}, te = ([e, t], { after: n, before: r, selection: o }) => {
  const { editor: i } = e(), l = o || ee([e, t]).pop() || { start: 0, end: 0 }, a = i.state.sliceDoc(l.start, l.end);
  T([e, t], `${r}${a}${n}`, l), Ne([e, t], { selections: [{ start: l.start + r.length, end: l.end + r.length }] });
}, Re = (e) => ({
  destroy: Kt.bind(void 0, e),
  focus: ue.bind(void 0, e),
  format: Ve.bind(void 0, e),
  getDoc: on.bind(void 0, e),
  insert: T.bind(void 0, e),
  load: Dn.bind(void 0, e),
  options: Hn.bind(void 0, e),
  reconfigure: zn.bind(void 0, e),
  select: Ne.bind(void 0, e),
  selections: ee.bind(void 0, e),
  update: En.bind(void 0, e),
  wrap: te.bind(void 0, e)
}), jn = `.ink-drop-zone{align-items:center;background-color:#00000080;color:var(--ink-internal-color);display:flex;inset:0;justify-content:center;position:var(--ink-internal-modal-position);z-index:100}.ink-drop-zone:not(.visible){display:none}.ink-drop-zone-modal{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);box-sizing:border-box;height:100%;max-height:20rem;max-width:40rem;padding:1rem;position:relative;width:100%}.ink-drop-zone-hide{cursor:pointer;height:1.75rem;position:absolute;right:.25rem;top:.25rem;width:1.75rem}.ink-drop-zone-hide svg{background-color:var(--ink-internal-block-background-color)}.ink-drop-zone-droppable-area{align-items:center;border:.2rem dashed var(--ink-internal-color);border-radius:.125rem;box-sizing:border-box;display:flex;flex-direction:column;font-size:1.25em;gap:1rem;height:100%;justify-content:center;padding:1rem;text-align:center}.ink-drop-zone-file-preview{align-items:center;display:flex;flex-wrap:wrap;gap:.5rem;max-width:25.5rem}.ink-drop-zone-file-preview-image{border:.125rem solid #222;border-radius:.125rem;box-sizing:border-box;height:6rem;object-fit:cover;padding:.5rem;width:6rem}
`, Vn = /* @__PURE__ */ p("<span>uploading files...</span>", 2), On = /* @__PURE__ */ p('<div class="ink-drop-zone"><style></style><div class="ink-drop-zone-modal"><div class="ink-drop-zone-droppable-area"><div class="ink-drop-zone-file-preview"></div><!#><!/></div><div class="ink-drop-zone-hide"><svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke="currentColor"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M10 14l2-2m0 0l2-2m-2 2l-2-2m2 2l2 2m7-2a9 9 0 11-18 0 9 9 0 0118 0z"></path></svg></div></div></div>', 18), Tn = /* @__PURE__ */ p('<img class="ink-drop-zone-file-preview-image">', 1), Nn = /* @__PURE__ */ p("<span>drop files here</span>", 2), In = () => {
  const [e, t] = B(0), [n, r] = B([]), [o, i] = B(!1), [l, a] = B(!1), [s, u] = W(), x = () => {
    a(!1);
  }, y = (f) => {
    if (s().options.files.dragAndDrop) {
      f.preventDefault(), f.stopPropagation();
      const h = f.dataTransfer;
      h?.files ? P(h.files) : (t(0), a(!1), r([]));
    }
  }, S = (f) => {
    s().options.files.dragAndDrop && (f.preventDefault(), t(e() + 1), a(!0));
  }, E = (f) => {
    s().options.files.dragAndDrop && (f.preventDefault(), t(e() - 1), e() === 0 && a(!1));
  }, A = (f) => {
    s().options.files.dragAndDrop && (f.preventDefault(), a(!0));
  }, j = (f) => {
    s().options.files.dragAndDrop && (f.preventDefault(), t(0), a(!1));
  }, F = (f) => {
    if (s().options.files.clipboard) {
      f.preventDefault();
      const h = f.clipboardData;
      h?.files && h.files.length > 0 && P(h.files);
    }
  }, P = (f) => {
    Array.from(f).forEach((h) => {
      r([...n(), h]);
    }), i(!0), a(!0), Promise.resolve(s().options.files.handler(f)).then((h) => {
      if (s().options.files.injectMarkup && h) {
        const N = `![](${h})`;
        T([s, u], N);
      }
    }).finally(() => {
      t(0), i(!1), a(!1), r([]);
    });
  };
  return Le(() => {
    document.addEventListener("dragenter", S), document.addEventListener("dragleave", E), document.addEventListener("dragover", A), document.addEventListener("drop", j), s().root.addEventListener("paste", F);
  }), at(() => {
    document.removeEventListener("dragenter", S), document.removeEventListener("dragleave", E), document.removeEventListener("dragover", A), document.removeEventListener("drop", j), s().root.removeEventListener("paste", F);
  }), (() => {
    const f = g(On), h = f.firstChild, N = h.nextSibling, D = N.firstChild, U = D.firstChild, ne = U.nextSibling, [X, oe] = b(ne.nextSibling), re = D.nextSibling;
    return h.textContent = jn, D.addEventListener("drop", y), k(U, c(lt, {
      get each() {
        return n().slice(0, 8);
      },
      children: (K) => (() => {
        const I = g(Tn);
        return ae((_) => {
          const Q = K.name, R = URL.createObjectURL(K);
          return Q !== _._v$ && ve(I, "alt", _._v$ = Q), R !== _._v$2 && ve(I, "src", _._v$2 = R), _;
        }, {
          _v$: void 0,
          _v$2: void 0
        }), I;
      })()
    })), k(D, c(v, {
      get when() {
        return o();
      },
      get fallback() {
        return g(Nn);
      },
      get children() {
        return g(Vn);
      }
    }), X, oe), re.$$click = x, ae(() => f.classList.toggle("visible", !!l())), me(), f;
  })();
};
Ce(["click"]);
const Rn = (e) => {
  const t = new L({
    dispatch: (n) => {
      const { options: r } = e;
      r.hooks.beforeUpdate(n.newDoc.toString()), t.update([n]), n.docChanged && r.hooks.afterUpdate(n.newDoc.toString());
    },
    state: Te(e)
  });
  return t;
}, qn = () => {
  const [e, t] = W(), n = Rn(e());
  return t(q(e(), {
    editor: n
  })), n.dom;
}, Wn = /* @__PURE__ */ p('<button class="ink-button" type="button"></button>', 2), $ = (e) => (() => {
  const t = g(Wn);
  return t.$$click = (n) => e.onclick(n), k(t, () => e.children), me(), t;
})();
Ce(["click"]);
const Fn = `.ink .ink-toolbar{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);bottom:.25rem;color:inherit;display:flex;flex-shrink:0;gap:2rem;overflow:auto;padding:.25rem;position:sticky;top:.25rem;z-index:10}.ink .ink-toolbar-group{display:flex}.ink .ink-toolbar .ink-button{align-items:center;background:none;border:none;border-radius:var(--ink-internal-border-radius);color:inherit;cursor:pointer;display:flex;height:2.25rem;justify-content:center;padding:.4rem;width:2.25rem}.ink .ink-toolbar .ink-button:hover{background-color:var(--ink-internal-block-background-color-on-hover)}.ink .ink-toolbar .ink-button>*{align-items:center;display:flex;height:100%}
`, Pn = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M6 4V10M6 16V10M6 10H14M14 10V4M14 10V16"></path></svg>', 4), Un = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-width="1.5" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M6.5 10H10.5C12.1569 10 13.5 11.3431 13.5 13C13.5 14.6569 12.1569 16 10.5 16H6.5V4H9.5C11.1569 4 12.5 5.34315 12.5 7C12.5 8.65686 11.1569 10 9.5 10"></path></svg>', 4), Xn = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M11 4L9 16M13 4H9M7 16H11"></path></svg>', 4), Kn = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M2.00257 16H17.9955M2.00055 4H18M7 10H18.0659M2 8.5V11.4999C2.4 11.5 2.5 11.5 2.5 11.5V11V10.5M4 8.5V11.4999H4.5V11V10.5"></path></svg>', 4), Qn = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M13 4L7 16"></path><path d="M5 7L2 10L5 13"></path><path d="M15 7L18 10L15 13"></path></svg>', 8), Yn = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 4L8 6"></path></svg>', 4), Zn = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H17.8294"></path><path d="M2 16H4"></path><path d="M7 10H17.8294"></path><path d="M2 10H4"></path><path d="M7 4H17.8294"></path><path d="M2 4H4"></path></svg>', 14), Gn = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H18"></path><path d="M2 17.0242C2.48314 17.7569 3.94052 17.6154 3.99486 16.7919C4.05315 15.9169 3.1975 16.0044 2.99496 16.0044M2.0023 14.9758C2.48544 14.2431 3.94282 14.3846 3.99716 15.2081C4.05545 16.0831 3.1998 16.0002 2.99726 16.0002"></path><path d="M7 10H18"></path><path d="M2.00501 11.5H4M2.00193 8.97562C2.48449 8.24319 3.9401 8.38467 3.99437 9.20777C4.05259 10.0825 2.04342 10.5788 2 11.4996"></path><path d="M7 4H18"></path><path d="M2 5.5H4M2.99713 5.49952V2.5L2.215 2.93501"></path></svg>', 14), Jn = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H17.8294"></path><path d="M5 15L3 17L2 16"></path><path d="M7 10H17.8294"></path><path d="M5 9L3 11L2 10"></path><path d="M7 4H17.8294"></path><path d="M5 3L3 5L2 4"></path></svg>', 14), eo = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M9.12127 10.881C10.02 11.78 11.5237 11.7349 12.4771 10.7813L15.2546 8.00302C16.2079 7.04937 16.253 5.54521 15.3542 4.6462C14.4555 3.74719 12.9512 3.79174 11.9979 4.74539L10.3437 6.40007M10.8787 9.11903C9.97997 8.22002 8.47626 8.26509 7.52288 9.21874L4.74545 11.997C3.79208 12.9506 3.74701 14.4548 4.64577 15.3538C5.54452 16.2528 7.04876 16.2083 8.00213 15.2546L9.65633 13.5999"></path></svg>', 4), to = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><rect x="2" y="4" width="16" height="12" rx="1"></rect><path d="M7.42659 7.67597L13.7751 13.8831M2.00208 12.9778L7.42844 7.67175"></path><path d="M11.9119 12.0599L14.484 9.54443L17.9973 12.9785"></path><path d="M10.9989 7.95832C11.551 7.95832 11.9986 7.52072 11.9986 6.98092C11.9986 6.44113 11.551 6.00354 10.9989 6.00354C10.4468 6.00354 9.99921 6.44113 9.99921 6.98092C9.99921 7.52072 10.4468 7.95832 10.9989 7.95832Z"></path></svg>', 10), no = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M10 13V4M10 4L13 7M10 4L7 7"></path><path d="M2 13V15C2 15.5523 2.44772 16 3 16H17C17.5523 16 18 15.5523 18 15V13"></path></svg>', 6), oo = /* @__PURE__ */ p('<input type="file">', 1), ro = /* @__PURE__ */ p('<div class="ink-toolbar"><style></style><div class="ink-toolbar-group"><!#><!/><!#><!/><!#><!/></div><div class="ink-toolbar-group"><!#><!/><!#><!/><!#><!/></div><div class="ink-toolbar-group"><!#><!/><!#><!/><!#><!/></div><div class="ink-toolbar-group"><!#><!/><!#><!/><!#><!/></div></div>', 36), io = () => {
  const [e, t] = W(), [n, r] = B(), o = (a) => {
    Ve([e, t], a), ue([e, t]);
  }, i = (a) => {
    const s = a.target;
    s?.files && Promise.resolve(e().options.files.handler(s.files)).then((u) => {
      const x = `![](${u})`;
      T([e, t], x), ue([e, t]);
    });
  }, l = () => {
    n()?.click();
  };
  return (() => {
    const a = g(ro), s = a.firstChild, u = s.nextSibling, x = u.firstChild, [y, S] = b(x.nextSibling), E = y.nextSibling, [A, j] = b(E.nextSibling), F = A.nextSibling, [P, f] = b(F.nextSibling), h = u.nextSibling, N = h.firstChild, [D, U] = b(N.nextSibling), ne = D.nextSibling, [X, oe] = b(ne.nextSibling), re = X.nextSibling, [K, I] = b(re.nextSibling), _ = h.nextSibling, Q = _.firstChild, [R, Fe] = b(Q.nextSibling), Pe = R.nextSibling, [ke, Ue] = b(Pe.nextSibling), Xe = ke.nextSibling, [Ke, Qe] = b(Xe.nextSibling), Y = _.nextSibling, Ye = Y.firstChild, [be, Ze] = b(Ye.nextSibling), Ge = be.nextSibling, [xe, Je] = b(Ge.nextSibling), et = xe.nextSibling, [tt, nt] = b(et.nextSibling);
    return s.textContent = Fn, k(u, c(v, {
      get when() {
        return e().options.toolbar.heading;
      },
      get children() {
        return c($, {
          onclick: () => o(m.Heading),
          get children() {
            return g(Pn);
          }
        });
      }
    }), y, S), k(u, c(v, {
      get when() {
        return e().options.toolbar.bold;
      },
      get children() {
        return c($, {
          onclick: () => o(m.Bold),
          get children() {
            return g(Un);
          }
        });
      }
    }), A, j), k(u, c(v, {
      get when() {
        return e().options.toolbar.italic;
      },
      get children() {
        return c($, {
          onclick: () => o(m.Italic),
          get children() {
            return g(Xn);
          }
        });
      }
    }), P, f), k(h, c(v, {
      get when() {
        return e().options.toolbar.quote;
      },
      get children() {
        return c($, {
          onclick: () => o(m.Quote),
          get children() {
            return g(Kn);
          }
        });
      }
    }), D, U), k(h, c(v, {
      get when() {
        return e().options.toolbar.codeBlock;
      },
      get children() {
        return c($, {
          onclick: () => o(m.CodeBlock),
          get children() {
            return g(Qn);
          }
        });
      }
    }), X, oe), k(h, c(v, {
      get when() {
        return e().options.toolbar.code;
      },
      get children() {
        return c($, {
          onclick: () => o(m.Code),
          get children() {
            return g(Yn);
          }
        });
      }
    }), K, I), k(_, c(v, {
      get when() {
        return e().options.toolbar.list;
      },
      get children() {
        return c($, {
          onclick: () => o(m.List),
          get children() {
            return g(Zn);
          }
        });
      }
    }), R, Fe), k(_, c(v, {
      get when() {
        return e().options.toolbar.orderedList;
      },
      get children() {
        return c($, {
          onclick: () => o(m.OrderedList),
          get children() {
            return g(Gn);
          }
        });
      }
    }), ke, Ue), k(_, c(v, {
      get when() {
        return e().options.toolbar.taskList;
      },
      get children() {
        return c($, {
          onclick: () => o(m.TaskList),
          get children() {
            return g(Jn);
          }
        });
      }
    }), Ke, Qe), k(Y, c(v, {
      get when() {
        return e().options.toolbar.link;
      },
      get children() {
        return c($, {
          onclick: () => o(m.Link),
          get children() {
            return g(eo);
          }
        });
      }
    }), be, Ze), k(Y, c(v, {
      get when() {
        return e().options.toolbar.image;
      },
      get children() {
        return c($, {
          onclick: () => o(m.Image),
          get children() {
            return g(to);
          }
        });
      }
    }), xe, Je), k(Y, c(v, {
      get when() {
        return e().options.toolbar.upload;
      },
      get children() {
        return c($, {
          onclick: l,
          get children() {
            return [g(no), (() => {
              const Z = g(oo);
              return r(Z), Z.addEventListener("change", i), Z.style.setProperty("display", "none"), Z;
            })()];
          }
        });
      }
    }), tt, nt), a;
  })();
}, ao = `.ink{color:var(--ink-internal-color, inherit);display:flex;flex-direction:var(--ink-internal-flex-direction, column);gap:1rem;padding:var(--ink-internal-editor-padding, 0)}.ink .cm-tooltip{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);font-family:inherit;padding:.25rem}.ink .cm-tooltip.cm-tooltip-autocomplete ul{font-family:inherit}.ink .cm-tooltip.cm-tooltip-autocomplete ul li.ink-tooltip-option{border-radius:var(--ink-internal-border-radius);padding:.25rem}.ink .cm-tooltip.cm-tooltip-autocomplete ul li.ink-tooltip-option[aria-selected]{background-color:#96969640}.ink .cm-completionLabel{font-family:inherit}.ink-mde,.ink-mde *{box-sizing:border-box}.ink-mde .cm-editor{display:flex;flex-direction:column;position:relative}.ink-mde .cm-scroller{align-items:flex-start;display:flex;font-family:var(--ink-internal-font-family);font-size:var(--ink-internal-editor-font-size);line-height:var(--ink-internal-editor-line-height);overflow-x:auto;position:relative}.ink-mde .cm-content{display:block;flex-grow:2;flex-shrink:0;margin:0;outline:none;padding:0;white-space:pre;word-wrap:normal}.ink-mde .cm-lineWrapping{flex-shrink:1;overflow-wrap:anywhere;white-space:break-spaces;word-break:break-word}.ink-mde .cm-line{font-family:var(--ink-internal-font-family);padding:0}.ink-mde .cm-line.cm-blockquote{background-color:var(--ink-internal-block-background-color);font-family:var(--ink-internal-code-font-family);padding:0 var(--ink-internal-block-padding);border-left:.25rem solid currentColor}.ink-mde .cm-line.cm-blockquote.cm-blockquote-open{border-top-left-radius:var(--ink-internal-border-radius);border-top-right-radius:var(--ink-internal-border-radius);padding-top:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-blockquote.cm-blockquote-close{border-bottom-left-radius:var(--ink-internal-border-radius);border-bottom-right-radius:var(--ink-internal-border-radius);padding-bottom:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock{background-color:var(--ink-internal-block-background-color);font-family:var(--ink-internal-code-font-family);padding:0 var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock.cm-codeblock-open{border-radius:var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0 0;padding-top:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock.cm-codeblock-close{border-radius:0 0 var(--ink-internal-border-radius) var(--ink-internal-border-radius);padding-bottom:var(--ink-internal-block-padding)}.ink-mde .cm-line .cm-code{background-color:var(--ink-internal-block-background-color);font-family:var(--ink-internal-code-font-family);padding:var(--ink-internal-inline-padding) 0}.ink-mde .cm-line .cm-code.cm-code-open{border-radius:var(--ink-internal-border-radius) 0 0 var(--ink-internal-border-radius);padding-left:var(--ink-internal-inline-padding)}.ink-mde .cm-line .cm-code.cm-code-close{border-radius:0 var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0;padding-right:var(--ink-internal-inline-padding)}.ink-mde .cm-image-backdrop{background-color:var(--ink-internal-block-background-color)}
`, lo = /* @__PURE__ */ p("<style> </style>", 2), so = () => {
  const [e] = W(), [t, n] = B(ie(e()));
  return st(() => {
    n(ie(e()));
  }), Le(() => {
    const r = window.matchMedia("(prefers-color-scheme: dark)"), o = (i) => {
      const {
        editor: l,
        root: a
      } = e();
      if (a.isConnected) {
        const s = ze(e());
        l.dispatch({
          effects: s
        }), n(ie(e()));
      } else
        r.removeEventListener("change", o);
    };
    r.addEventListener("change", o);
  }), (() => {
    const r = g(lo), o = r.firstChild;
    return ae(() => o.data = `.ink {
  ${t().join(`
  `)}
}
${ao}`), r;
  })();
}, co = /* @__PURE__ */ p('<div class="ink ink-mde"><!#><!/><!#><!/><!#><!/><!#><!/></div>', 10), uo = () => {
  const [e, t] = W(), n = (r) => {
    t(q(e(), {
      root: r
    }));
  };
  return (() => {
    const r = g(co), o = r.firstChild, [i, l] = b(o.nextSibling), a = i.nextSibling, [s, u] = b(a.nextSibling), x = s.nextSibling, [y, S] = b(x.nextSibling), E = y.nextSibling, [A, j] = b(E.nextSibling);
    return n(r), ot(r, Ht, !1, !0), k(r, c(so, {}), i, l), k(r, c(v, {
      get when() {
        return e().options.files.clipboard || e().options.files.dragAndDrop;
      },
      get children() {
        return c(In, {});
      }
    }), s, u), k(r, c(v, {
      get when() {
        return e().options.interface.toolbar;
      },
      get children() {
        return c(io, {});
      }
    }), y, S), k(r, c(qn, {}), A, j), me(), r;
  })();
}, qe = ct([() => de(), (e) => typeof e == "function" ? e(de()) : e]), fo = (e) => c(qe.Provider, {
  get value() {
    return e.store;
  },
  get children() {
    return e.children;
  }
}), W = () => dt(qe), We = (e) => c(fo, {
  get store() {
    return e.store;
  },
  get children() {
    return c(uo, {
      get store() {
        return e.store;
      }
    });
  }
}), So = (e) => e, mo = (e, t = {}) => {
  const n = ge(t);
  return po(), rt(() => c(We, {
    store: n
  }), e), Re(n);
}, Mo = (e, t = {}) => e.querySelector(Dt) ? mo(e, t) : go(e, t), go = (e, t = {}) => {
  const n = ge(t);
  return it(() => c(We, {
    store: n
  }), e), Re(n);
}, Ao = (e = {}) => (ge(e), ""), po = () => {
  let e, t;
  e = window._$HY || (window._$HY = {
    events: [],
    completed: /* @__PURE__ */ new WeakSet(),
    r: {}
  }), t = (n) => n && n.hasAttribute && (n.hasAttribute("data-hk") ? n : t(n.host && n.host instanceof Node ? n.host : n.parentNode)), ["click", "input"].forEach((n) => document.addEventListener(n, (r) => {
    let o = r.composedPath && r.composedPath()[0] || r.target, i = t(o);
    i && !e.completed.has(i) && e.events.push([i, r]);
  })), e.init = (n, r) => {
    e.r[n] = [new Promise((o, i) => r = o), r];
  }, e.set = (n, r, o) => {
    (o = e.r[n]) && o[1](r), e.r[n] = [r];
  }, e.unset = (n) => {
    delete e.r[n];
  }, e.load = (n, r) => {
    if (r = e.r[n])
      return r[0];
  };
};
export {
  O as Appearance,
  M as Extensions,
  m as Markup,
  G as PluginType,
  ce as Selection,
  Mo as default,
  So as defineOptions,
  mo as hydrate,
  Mo as ink,
  go as render,
  Ao as renderToString,
  po as solidPrepareForHydration
};
//# sourceMappingURL=client.js.map
